Option Explicit On 
Module Prolog

    Public Function StartProlog() As Boolean
        Dim n As Byte
        Dim PassTbl1(15) As Byte
        Dim PassTbl2(15) As Byte

        Time = GetTickCount()

        ' sprawdzenie wersji biblioteki
        System.Console.WriteLine("")
        System.Console.WriteLine("Odczyt wersji biblioteki")
        TVTT_GetVersion(Ver, SubVer, APIVer)
        System.Console.WriteLine("Wersja pliku" & vbTab & vbTab & vbTab & Ver & "." & SubVer)
        System.Console.WriteLine("Wersja API" & vbTab & vbTab & vbTab & APIVer)

        ' otwarcie dostepu do TeleTokenu
        System.Console.Write("Otwarcie dostepu do TeleTokenu")
        TokenInfoTblSize = TVTTTI_TABLE_SIZE   ' wpisanie rozmiaru tablicy

        Status = TVTT_FindToken(TokenH, 10, TOKEN_ID, TOKEN_ID_MASK, 0, TokenInfoTblSize, TokenInfoTbl(0))
        If (Status <> 0) Then
            System.Console.WriteLine(vbTab & IntToHex((Status \ 8), 2) & ":" & IntToHex((Status And &HFF), 2))
        Else
            System.Console.WriteLine(vbTab & "OK")
        End If

        n = 0
        While (n < TokenInfoTblSize)
            If (TokenInfoOffsetTbl(n) = TVTTTI_ID) Then
                System.Console.WriteLine(vbTab & vbTab & vbTab & vbTab & TokenInfoTextTbl(n) & _
                                        IntToHex(TokenInfoTbl(TokenInfoOffsetTbl(n)), 8))
            Else
                System.Console.WriteLine(vbTab & vbTab & vbTab & vbTab & TokenInfoTextTbl(n) & _
                                        TokenInfoTbl(TokenInfoOffsetTbl(n)))
            End If
            n = n + 1
        End While

        ' odczytanie nr. seryjnego TeleTokenu
        System.Console.Write("Odczyt nr. ser. TeleTokenu:")
        Status = TVTT_GetSerialNr(TokenH, 10, SerialNr(0))

        If (Status <> 0) Then
            System.Console.WriteLine(vbTab & vbTab & IntToHex((Status \ 2), 2) & ":" & IntToHex(Status And &HFF, 2))
        Else
            System.Console.WriteLine(vbTab & "OK")
        End If
        System.Console.WriteLine("Numer seryjny:" & vbTab & vbTab & vbTab & IntToHex(SerialNr(0), 2) & IntToHex(SerialNr(1), 2) + IntToHex(SerialNr(2), 2) + IntToHex(SerialNr(3), 2))

        ' rozpoczecie sesji
        Console.Write("Rozpoczecie sesji")
        Status = TVTT_StartSession(TokenH, 1)
        If (Status <> 0) Then
            System.Console.WriteLine(vbTab & vbTab & IntToHex((Status \ 2), 2) & ":" & IntToHex(Status And &HFF, 2))
        Else
            System.Console.WriteLine(vbTab & vbTab & "OK")
        End If

        ' otwarcie sesji
        System.Console.Write("Otwarcie sesji")

        ZeroMemory(OutDataA, 16, 0)
        ZeroMemory(OutDataB, 16, 0)
        ZeroMemory(InDataA, 16, 0)
        ZeroMemory(InDataB, 16, 0)

        OutKey = 0                                          ' znacznik wiamoci nie szyfrowanej
        TVTT_Rand(OutDataA, 0)                              ' wylosowanie tablicy losowej
        OutDataB(TVTTD_CMD) = TVTTC_OPEN                    ' rozkaz otwarcia sesji
        OutDataB(TVTTD_PARAM1) = 0                          ' numer hasa proponowanego przez PC

        TVTT_CalcAuth(OutDataA, OutDataB)                   ' policzenie bloku kontrolnego
        Status = TVTT_Talk(TokenH, 1, OutKey, OutDataA(0), OutDataB(0), InKey, InDataA(0), InDataB(0))
        For n = 0 To 15
            PassTbl1(n) = PassTbl((OutDataB(TVTTD_PARAM1) * 16) + n)
            PassTbl2(n) = PassTbl((InDataB(TVTTD_PARAM1) * 16) + n)
        Next        
        TVTT_CalcSessionKey(SessionKey, PassTbl1, OutDataA, PassTbl2, InDataA) ' policzenie klucza sesji
        If (Status <> 0) Then
            System.Console.WriteLine(vbTab & vbTab & vbTab & IntToHex((Status \ 2), 2) & ":" & IntToHex((Status And &HFF), 2))
        ElseIf (TVTT_CheckAuth(InDataA, InDataB) <> 0) Then
            System.Console.WriteLine(vbTab & vbTab & vbTab & "Blad bloku kontrolnego!")
        ElseIf (InDataB(TVTTD_STATUS) <> 0) Then
            System.Console.WriteLine(vbTab & vbTab & vbTab & IntToHex(InDataB(TVTTD_STATUS), 4))
        Else
            System.Console.WriteLine(vbTab & vbTab & vbTab & "OK")
        End If
    End Function
End Module